const Generator = require('yeoman-generator');
const path = require('path');
const mkdirp = require('mkdirp');

module.exports = class extends Generator {
    initializing() {
        this.props = {};
    }

    prompting() {
        var prompts = [{
            name: 'componentName',
            message: 'Enter component name',
            default: 'Component'
        },
            {
                name: 'componentName',
                message: 'Enter expected path',
                default: './'
            }
        ];

        return this.prompt(prompts).then((answers) => {
            this.props = answers;
        });
    }

    writing() {
        this.props.fileName = camelCaseToDash(this.props.componentName);
        mkdirp.sync(this.destinationPath(`projects/${this.props.fileName}`));
        this.fs.copyTpl(
            this.templatePath('component-folder/component.jsx'),
            this.destinationPath(`projects/${this.props.fileName}/${this.props.fileName}.jsx`),
            this.props
        );
        this.fs.copyTpl(
            this.templatePath('component-folder/style.scss'),
            this.destinationPath(`projects/${this.props.fileName}/${this.props.fileName}.scss`)
        );
        this.fs.copyTpl(
            this.templatePath('component-folder/index.js'),
            this.destinationPath(`projects/${this.props.fileName}/index.js`),
            this.props
        );
        this.fs.copyTpl(
            this.templatePath('component-folder/component.spec.jsx'),
            this.destinationPath(`projects/${this.props.fileName}/${this.props.fileName}.spec.jsx`),
            this.props
        );
    }
};

function camelCaseToDash( str ) {
    return str.replace( /([a-z])([A-Z])/g, '$1-$2' ).toLowerCase();
}
